---

# creates database backup
#   - postgres
#     - executed on stage specific server: {{ stage }}-postgres-01
#     - creates database backup for specific database

# Parameters:
#   playbook inventory
#     stage := the name of the stage (e.g. dev, int, qa, prod)
#     tenant_id := (unique key for the tenant, e.g. customer)
#     cluster_name := (business name for the cluster, e.g. product, department )
#     cluster_size := (WIP node count for the cluster)
#     cluster_service := (service to setup, e.g. 'connect', ...)
#     cluster_features := (optional features to use, e.g. ['wordpress', 'resubmission', ...])
#     custom_backup_name := defines a substring for backup file => {{ stage }}_{{ tenant_id }}_{{ cluster_name }}_{{ cluster_service }}__gehtdichnixan.sql
#   smardigo message callback
#     scope_id := (scope id of the management process)
#     process_instance_id := (process instance id of the management process)
#     smardigo_management_action := (smardigo management action anme of the management process)

#############################################################
#   Creating inventory dynamically for given parameters
#############################################################

- hosts: localhost
  connection: local
  gather_facts: false

  pre_tasks:
    - name: "Check if ansible version is at least {{ ansible_minimal_version }}"
      assert:
        that:
          - ansible_version.string is version(ansible_minimal_version, ">=")
        msg: "The ansible version has to be at least {{ ansible_minimal_version }}"

#     add virtual server to load stage specific variables as context
    - name: "Add <{{ stage }}-virtual-host-to-read-groups-vars> to hosts"
      add_host:
        name: "{{ stage }}-virtual-host-to-read-groups-vars"
        groups:
        - "stage_{{ stage }}"
      changed_when: False

  tasks:
    - name: "Add postgres servers to hosts if necessary"
      add_host:
        name: "{{ stage }}-postgres-01"
        groups:
        - "stage_{{ stage }}"
        - "{{ item }}"
      changed_when: False
      with_items: "{{ cluster_features }}"
      when: item in ['connect', 'management_connect', 'keycloak', 'webdav', 'gitea', 'pdns']

    - name: "Add maria servers to hosts if necessary"
      add_host:
        name: "{{ stage }}-maria-01"
        groups:
        - "stage_{{ stage }}"
        - "{{ item }}"
      changed_when: False
      with_items: "{{ cluster_features }}"
      when: item in ['connect_wordpress']

#############################################################
#   Creating database backups for created inventory
#############################################################

- hosts: "stage_{{ stage }}:!{{ stage }}-virtual-host-to-read-groups-vars"
  serial: "{{ serial_number | default(1) }}"
  remote_user: root
  vars:
    database_backup_state: dump
    ansible_ssh_host: "{{ stage_server_domain }}"

  roles:
    - role: connect_postgres
      when: "'connect' in group_names"

    - role: gitea_postgres
      when: "'gitea' in group_names"

    - role: keycloak_postgres
      when: "'keycloak' in group_names"

#    - role: pdns_admin_postgres
#      when: "'pdns' in group_names"

#    - role: pdns_postgres
#      when: "'pdns' in group_names"

    - role: webdav_postgres
      when: "'webdav' in group_names"

    - role: connect_wordpress_maria
      when: "'connect_wordpress' in group_names"

#############################################################
#   Sending smardigo management message to process
#############################################################

- hosts: "{{ stage }}-virtual-host-to-read-groups-vars"
  serial: "{{ serial_number | default(1) }}"
  gather_facts: false
  connection: local
  run_once: true
  vars:
    connect_jwt_username: "{{ management_admin_username }}"

  tasks:
    - name: "Sending smardigo management message to <{{ shared_service_url_management }}>"
      include_tasks: tasks/smardigo_management_message.yml
